%# BEGIN BPS TAGGED BLOCK {{{
%#
%# COPYRIGHT:
%#
%# This software is Copyright (c) 1996-2023 Best Practical Solutions, LLC
%#                                          <sales@bestpractical.com>
%#
%# (Except where explicitly superseded by other copyright notices)
%#
%#
%# LICENSE:
%#
%# This work is made available to you under the terms of Version 2 of
%# the GNU General Public License. A copy of that license should have
%# been provided with this software, but in any event can be snarfed
%# from www.gnu.org.
%#
%# This work is distributed in the hope that it will be useful, but
%# WITHOUT ANY WARRANTY; without even the implied warranty of
%# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
%# General Public License for more details.
%#
%# You should have received a copy of the GNU General Public License
%# along with this program; if not, write to the Free Software
%# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
%# 02110-1301 or visit their web page on the internet at
%# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html.
%#
%#
%# CONTRIBUTION SUBMISSION POLICY:
%#
%# (The following paragraph is not intended to limit the rights granted
%# to you to modify and distribute this software under the terms of
%# the GNU General Public License and is only of importance to you if
%# you choose to contribute your changes and enhancements to the
%# community by submitting them to Best Practical Solutions, LLC.)
%#
%# By intentionally submitting any modifications, corrections or
%# derivatives to this work, or any other work intended for use with
%# Request Tracker, to Best Practical Solutions, LLC, you confirm that
%# you are the copyright holder for those contributions and you grant
%# Best Practical Solutions,  LLC a nonexclusive, worldwide, irrevocable,
%# royalty-free, perpetual, license to use, copy, create derivative
%# works based on those contributions, and sublicense and distribute
%# those contributions and any derivatives thereof.
%#
%# END BPS TAGGED BLOCK }}}
<& /Admin/Elements/Header, Title => $title &>
<& /Elements/Tabs &>
<& /Elements/ListActions, actions => \@results &>

<form method="post" name="ModifyTemplate" id="ModifyTemplate" action="Template.html">
%if ($Create ) {
<input type="hidden" class="hidden" name="Template" value="new" />
% } else {
<input type="hidden" class="hidden" name="Template" value="<%$TemplateObj->Id%>" />
% }

%# hang onto the queue id
<input type="hidden" class="hidden" name="Queue" value="<%$Queue%>" />
<& /Admin/Elements/ModifyTemplate,
    Name        => $TemplateObj->Name // $ARGS{Name},
    Description => $TemplateObj->Description // $ARGS{Description},
    Content     => $TemplateObj->Content // $ARGS{Content},
    Type        => $TemplateObj->Type // $ARGS{Type},
&>
<& /Elements/Submit, Label => $SubmitLabel, Reset => 1 &>
</form>


<%INIT>

my $TemplateObj = RT::Template->new( $session{'CurrentUser'} );
my $QueueObj;
my $SubmitLabel;
my $title;
my @results;

if ( !$Create ) {
    if ( $Template eq 'new' ) {
        my ( $val, $msg )
            = $TemplateObj->Create( Queue => $Queue, Name => $Name, Type => $Type );
        push @results, $msg;
    } else {
        $TemplateObj->Load($Template) || Abort( loc('No Template') );
    }

}

if ( $TemplateObj->Id() ) {
    $Queue    = $TemplateObj->Queue;
    $QueueObj = $TemplateObj->QueueObj;

    my @attribs = qw( Name Description Queue Type Content );
    my @aresults = UpdateRecordObject( AttributesRef => \@attribs,
                                       Object        => $TemplateObj,
                                       ARGSRef       => \%ARGS
                                     );
    push @results, @aresults;

    my ( $ok, $msg ) = $TemplateObj->CompileCheck;
    push @results, $msg if !$ok;
} else {
    $Create = 1;
    $QueueObj = RT::Queue->new( $session{'CurrentUser'} );
    $QueueObj->Load($Queue);
}

if ($Create) {
    $title = loc( 'Create a new template for queue [_1]', $QueueObj->Name );
    $SubmitLabel = loc('Create');
} else {

    $title = loc( 'Modify template [_1] for queue [_2]', loc( $TemplateObj->Name()), $QueueObj->Name  );
    $SubmitLabel = loc('Save Changes');
}

</%INIT>
<%ARGS>
$Queue => ''
$Template => ''
$Create => undef
$Name => undef
$Type => undef
</%ARGS>
